#ifndef Laser_H
#define Laser_H

#include <Vec2.h>
using namespace Framework;

class Karte;

class Laser
{
private:
	int ref;
	int id;
	Vec2< double > pos;
	Vec2< double > speed;
	double intensity;
	int sNum;

public:
	// Konstruktor
	Laser( int id, Vec2< double > pos, Vec2< double > speed, int sNum, double intensity );
	// nicht constant
	void tick( double tickVal, Karte *zMap );
	// constant
	int getId() const;
	int getSpieler() const;
	Vec2< double > getPos() const;
	Vec2< double > getSpeed() const;
	double getIntensity() const;
	// Reference Counting
	Laser *getThis();
	Laser *release();
};

#endif